<?php
/*
LXDWARE LXD Dashboard - A web-based interface for managing LXD servers
Copyright (C) 2020-2021  LXDWARE.COM

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//Start session if not already started
if (!isset($_SESSION)) {
  session_start();
}

//Require code from lxd-dashboard/backend/config/db.php
require_once('../config/db.php');

function logEvent($action, $remote, $project, $object, $status_code, $message, $user_id = 0){
  $logs_enabled_value = retrievePreference("logs_enabled");

  if ($logs_enabled_value == 'true'){
    $hostname = gethostname();

    if ($user_id == 0){
      $user_id = (!empty($_SESSION['user_id'])) ? $_SESSION['user_id'] : 0;
    }
    
    $event_added = addLogEvent($action, $remote, $project, $object, $status_code, $message, $hostname, $user_id);
  }
}
?>